:: 
:: xavierjohn22's AUTO DEODEX
:: File: AutoDEOToolMain.bat
:: Description: Tool to automate deodexing
:: Fix : softdx
@echo off
java -version 
if errorlevel 1 goto errjava
cls
cls
COLOR 0A
mode con:cols=100 lines=40
setLocal EnableDelayedExpansion
set useversion=1.4.1
set api=17
set smaliversion=smali-%useversion%.jar
set baksmaliversion=baksmali-%useversion%.jar
set ignore=0
set complevel=9
set optiapk=0
set optijar=0
:restart
if not exist deodexed_JAR md deodexed_JAR
if not exist deodexed_APK md deodexed_APK
if not exist optimized_JAR md optimized_JAR
if not exist optimized_APK md optimized_APK
if %ignore% == 0 (set tmpv=OFF) else (set tmpv= ON)
if %useversion%==1.4.1 (set tmpuseversion=1.4.1)
if %useversion%==1.4.0 (set tmpuseversion=1.4.0)
if %useversion%==1.3.2 (set tmpuseversion=1.3.2)
if %useversion%==1.2.6 (set tmpuseversion=1.2.6)
if %useversion%==1.2.3 (set tmpuseversion=1.2.3)
set smaliversion=smali-%useversion%.jar
set baksmaliversion=baksmali-%useversion%.jar
echo --------------------------------------------------------------------------------------------
echo 				      AUTO DEODEX TOOL 1.0.3
echo 				     -by xavierjohn22, sggua-
echo --------------------------------------------------------------------------------------------
echo USING SMALI-BAKSMALI VERSION : %tmpuseversion%, change version using menu (50)
echo smali file is                : %smaliversion%
echo baksmali file is             : %baksmaliversion%
echo Ignore Mode is set to        : [%tmpv%] toggle using menu (51)
echo Compression level is set to  : [%complevel%] set using menu (52)
echo API number is set to         : [%api%] set using menu (53)
echo --------------------------------------------------------------------------------------------
echo BASICS:
echo   1    DEODEX ALL  (Stock Rom)
echo   2    DEODEX ALL  (Specify custom bootclasspath)
echo   3    DEODEX APKs (Stock Rom)
echo   4    DEODEX APKs (Specify custom bootclasspath)
echo   5    DEODEX JARs (Stock Rom)
echo   6    DEODEX JARs (Specify custom bootclasspath)
echo ADVANCED:
echo   20   Optimize JARs
echo   21   Optimize APKs
echo TOOLS:
echo   30   Clean up (_app, _framework, deodexed_APK, deodexed_JAR)
echo   31   Clean up (optimized_APK, optimized_JAR)
echo   32   Clean up (All folders)
echo SETTINGS TOGGLE:
echo   50   Change smali and baksmali version
echo   51   Ignore Mode ON/OFF (USE WITH CAUTION!)
echo   52   Set compression level for optimization
echo   53   Change API number
echo HELP:
echo   98   Display How-To
echo   99   Exit
echo --------------------------------------------------------------------------------------------
SET menunr=
SET /P menunr=PLEASE CHOOSE TASK: 
if '%menunr%'=='' (
cls
goto :restart
)
IF %menunr%==1 (goto stock)
IF %menunr%==2 (goto nonstock)
IF %menunr%==3 (goto deoapk)
IF %menunr%==4 (goto deoapkbootclass)
IF %menunr%==5 (goto deojar)
IF %menunr%==6 (goto deojarbootclass)
IF %menunr%==20 (goto optijars)
IF %menunr%==21 (goto optiapks)
IF %menunr%==30 (goto cleanone)
IF %menunr%==31 (goto cleantwo)
IF %menunr%==32 (goto cleanall)
IF %menunr%==50 (goto setsbversion)
IF %menunr%==51 (goto ign)
IF %menunr%==52 (goto setcomplevel)
IF %menunr%==53 (goto setapi)
IF %menunr%==98 (goto help)
IF %menunr%==99 (goto quit)
:nope
echo ERROR: Not part of the MENU
PAUSE
cls
goto restart
:setsbversion
echo.
echo  SET SMALI-BAKSMALI VERSION: 
echo    1 = 1.4.1
echo    2 = 1.4.0
echo    3 = 1.3.2
echo    4 = 1.2.6
echo    5 = 1.2.3
echo.
SET /P sbversion=Please choose smali-baksmali version:
if '%sbversion%'=='' goto :setsbversion
IF %sbversion%==1 (
set useversion=1.4.1
goto restart
)
IF %sbversion%==2 (
set useversion=1.4.0
goto restart
)
IF %sbversion%==3 (
set useversion=1.3.2
goto restart
)
IF %sbversion%==4 (
set useversion=1.2.6
goto restart
)
IF %sbversion%==5 (
set useversion=1.2.3
goto restart
)
:: wrong choice made
@echo Wrong choice, please make a valid selection!
goto :setsbversion
cls
goto restart
:ign
if %ignore% == 0 (set ignore=1) else (set ignore=0)
cls
goto restart
::----------------STOCK APKs and JARs
:stock
:: _framework folder
:: for loop call to 02deodexJAR
FOR %%F IN (_framework\*.jar) DO call 02deodexJAR %%F %ignore% %complevel% %api%
:: _app folder
:: for loop call to 01deodexAPK
FOR %%F IN (_app\*.apk) DO call 01deodexAPK %%F %ignore% %complevel% %api%
cls
goto restart
::----------------NON STOCK APKs and JARs
:nonstock
:: _framework folder
set INPUT=
set /P INPUT=Enter Custom BootClassPath (abc.jar:def.jar:ghi.jar): %=%
:: for loop call to 04customJAR
FOR %%F IN (_framework\*.jar) DO call 04customJAR %%F %INPUT% %ignore% %complevel% %api%
:: _app folder
:: for loop call to 03customAPK
FOR %%F IN (_app\*.apk) DO call 03customAPK %%F %INPUT% %ignore% %complevel% %api%
cls
goto restart
::----------------APKs ONLY
:deoapk
:: for loop call to 01deodexAPK
FOR %%F IN (_app\*.apk) DO call 01deodexAPK %%F %ignore% %complevel% %api%
goto restart
:deoapkbootclass
set INPUT=
set /P INPUT=Enter Custom BootClassPath (abc.jar:def.jar:ghi.jar): %=%
FOR %%F IN (_app\*.apk) DO call 03customAPK %%F %INPUT% %ignore% %complevel% %api%
cls
goto restart
::----------------JARs ONLY
:deojar
FOR %%F IN (_framework\*.jar) DO call 02deodexJAR %%F %ignore% %complevel% %api%
cls
goto restart
:deojarbootclass
set INPUT=
set /P INPUT=Enter Custom BootClassPath (abc.jar:def.jar:ghi.jar): %=%
FOR %%F IN (_framework\*.jar) DO call 04customJAR %%F %INPUT% %ignore% %complevel% %api%
cls
goto restart
::-----------------OPTIMIZED
:optijars
set optiapk=0
set optijar=1
FOR %%F IN (deodexed_JAR\*.jar) DO call 05optimizedFiles %%F %complevel%
echo DONE
pause
cls
goto restart
:optiapks
set optiapk=1
set optijar=0
FOR %%F IN (deodexed_APK\*.apk) DO call 05optimizedFiles %%F %complevel%
echo DONE
pause
cls
goto restart
:setcomplevel
set /P tmpcomplevel=Enter Compression Level (0-9) : %=%
if '%tmpcomplevel%'=='' goto :setcomplevel
if %tmpcomplevel% GTR 9 (
echo Invalid compression level, choose between 0-9
goto :setcomplevel
)
if %tmpcomplevel% LSS 0 (
echo Invalid compression level, choose between 0-9
goto :setcomplevel
)
set complevel=%tmpcomplevel%
cls
goto restart
:setapi 
echo Android versions:  1.5 1.6 2.1 2.2 2.3 3.0 3.1 3.2 4.0 4.0.3 4.0.4 4.1.0  4.1.1 4.2.0
echo API numbers  are:   3   4   7   8   10  11  12  13  14   15   15    16     16     17
set /P tmpapi=Enter API number (see above) : %=%
if '%tmpapi%'=='' goto :setapi
if not %tmpapi% == 17 (
if not %tmpapi% == 16 (
if not %tmpapi% == 15 (
if not %tmpapi% == 14 (
if not %tmpapi% == 13 (
if not %tmpapi% == 12 (
if not %tmpapi% == 11 (
if not %tmpapi% == 10 (
if not %tmpapi% == 8 (
if not %tmpapi% == 7 (
if not %tmpapi% == 4 (
if not %tmpapi% == 3 (
echo Invalid API number [%tmpapi%]!
goto :setapi
)
)
)
)
)
)
)
)
)
)
)
)
set api=%tmpapi%
cls
goto restart
::-------------------------------
:cleanone
echo  This will delete all files in the following folders:
echo  (_app, _framework, deodexed_APK, deodexed_JAR) Proceed?
echo    1 = YES
echo    2 = CANCEL
SET menunC=
SET /P menunC=Please make your decision: 
if '%menunC%'=='' goto :cleanone
IF %menunC%==1 (goto clearYES)
IF %menunC%==2 (goto clearNO)
:: wrong choice made
@echo Wrong choice, please make a valid selection!
goto cleanone
:clearYES
@rd /s /q _app
@rd /s /q _framework
@rd /s /q deodexed_APK
@rd /s /q deodexed_JAR
@md _app
@md _framework
@md deodexed_APK
@md deodexed_JAR
echo DONE, folders cleaned.
pause
cls
goto restart
:clearNO
cls
goto restart
:cleantwo
echo  This will delete all files in the following folders:
echo  (optimized_APK, optimized_JAR) Proceed?
echo    1 = YES
echo    2 = CANCEL
SET menunD=
SET /P menunD=Please make your decision: 
if '%menunD%'=='' goto :cleantwo
IF %menunD%==1 (goto yesOPT)
IF %menunD%==2 (goto noOPT)
:: wrong choice made
@echo Wrong choice, please make a valid selection!
goto cleantwo
:yesOPT
@rd /s /q optimized_APK
@rd /s /q optimized_JAR
@md optimized_APK
@md optimized_JAR
echo DONE, folders cleaned.
pause
cls
goto restart
:noOPT
cls
goto restart
:cleanall
echo  This will delete all files in all folders, Proceed?
echo    1 = YES
echo    2 = CANCEL
SET menunE=
SET /P menunE=Please make your decision: 
if '%menunE%'=='' goto :cleanall
IF %menunE%==1 (goto yestoall)
IF %menunE%==2 (goto notoall)
:: wrong choice made
@echo Wrong choice, please make a valid selection!
goto :cleanall
:yestoall
@rd /s /q _app
@rd /s /q _framework
@rd /s /q deodexed_APK
@rd /s /q deodexed_JAR
@rd /s /q optimized_APK
@rd /s /q optimized_JAR
@md _app
@md _framework
@md deodexed_APK
@md deodexed_JAR
@md optimized_APK
@md optimized_JAR
echo DONE, folders cleaned.
pause
cls
goto restart
:notoall
cls
goto restart
::-------------------------------
:help
cls
echo.
echo FILES:
echo [*] _app, _framework, deodexed_APK, deodexed_JAR (directory)
echo [*] AutoDEOToolMain.bat
echo [*] 01deodexAPK.bat, 02deodexJAR.bat, 03customAPK.bat, 04customJAR.bat
echo [*] 7za.exe, ReadMeHistory.txt
echo [*] smali-1.2.3.jar, smali-1.2.6.jar, smali-1.3.2.jar, smali-1.4.0.jar smali-1.4.1.jar
echo [*] baksmali-1.2.3.jar, baksmali-1.2.6.jar, baksmali-1.3.2.jar baksmali-1.4.0.jar baksmali-1.4.1.jar
echo. 
echo NOTES:
echo [*] As usual, you would probably want a deodexed framework first,
echo     to meet the requirements your apk files
echo [*] Place framework files and odex files in _framework folder
echo.
echo USAGE:
echo [*] Double click AutoDEOToolMain.bat
echo.
echo HELP:
echo [*] To deodex framework files,
echo [*] Place the JARs and corresponding ODEX files in the directory "_framework".
echo [*] Otherwise, place deodexed framework JARs into the directory "deodexed_JAR".
echo [*] To deodex APKs files,
echo [*] Place the APKs and corresponding ODEX files in the directory "_app".
echo.
echo [*] 1 is for stock android deodexing
echo [*] 2 is for non stock, such as sense, miui where you can put a custom bootclasspath
echo [*] 3 to 6 options are for deodexing apks only or jars with 1 and 2 functionality
echo [*] 51 toggles ignore mode. When on, it ignores the missing classpath's of files
echo     (WARNING: Use carefully)
echo [*] If an apk/jar had encountered an error when deodexing, its left behind.
echo [*] deodexed_JAR = output for deodexed framework (check framework directory for residual files)
echo [*] deodexed_APK = output for deodexed APKs
echo.
echo CREDITS:
echo [*] JesusFreke, Daneshm90's script and crzyruski Auto-Deodexer
echo [*] http://www.7-zip.org - 7za commandline version
echo [*] Sergiy Gorichenko, V1.0.3
pause
cls
goto restart
:errjava
cls
echo Java was not found, you will not be able to sign apks or use apktool
PAUSE
goto restart
:quit
